#ifndef CHierDimstack_H
#define CHierDimstack_H

#include <xmdv/CHierDisplay.h>
#include <xmdv/Vec2.h>

class CHierDimstack : public CHierDisplay 
{
private: 
    //variables for drawing
    ARR<double> mean;
    ARR<double> max;
    ARR<double> min;

    ARR<int> contrib0;
    ARR<int> contrib1;
    ARR<int> contrib2;
    ARR<int> contrib;

    RGBt color;
    double alpha;

public:
	CHierDimstack(CHierDisplayInformation* hier_info);

private:
	//draw a single cluster;
	void DrawSingleCluster(Cluster &c, bool brushed);
    void DrawAxes();
	//set parameters used for drawing;
	void SetParameters();
	//free space used for drawing;
	void FreeSpace();
    
    //draw a complete band
    void hierDimstackDrawSingleNodeBand2(const ARR<double> &data0, const ARR<double> &data1, const ARR<double> &data2);
    //draw band of level k
    void traceBand(int k);
    //draw a bin in a band
    void DrawSingleDimstackBin2();
    //calculate the distance factor of a bin in the band
    double distanceFactor();
    void DrawSingleDimstackBin(grCanvas *canvas, const ARR<double> &data, const ARR<double> &size);
    void comp_pixel_size();

    void DrawSingleNodeBand(Cluster &c, double density, bool brushed);
    void InputMouseMotion(int x, int y);

};

#endif



