#ifndef CHierParoord_H
#define CHierParoord_H

#include <xmdv/CHierDisplay.h>
#include <xmdv/CParcoord.h>
#include <xmdv/Vec2.h>

class CHierParcoord : public CHierDisplay, public CParcoord
{
protected:
	// Set of local variables to maintain the current state of interaction
	int axis;
	bool xor_needs_undo;

private: 
	ARR<Vec2> poly;
	double* mapedX;
	double* mapedYMean;
	double* mapedYMax;
	double* mapedYMin;
	double* para;
	Vec2 lo, hi;
    int poly_length;

public:
	CHierParcoord(CHierDisplayInformation* hier_info);
	~CHierParcoord();

	void Draw();
	bool TestDimensionality();  

//private:
	//draw a single cluster;
	void DrawSingleCluster(Cluster &c, bool brushed);
    void DrawSingleClusterWithTwoAxes(Cluster &c, ARR<double> mean_max, ARR<double> mean_min, ARR<double> max_max, 
                                                ARR<double> max_min, ARR<double> min_max, ARR<double> min_min, bool brushed);
    void DrawAxes();
	//set parameters used for drawing;
	void SetParameters();
	//free space used for drawing;
	void FreeSpace();

    void DrawSingleNodeBand(Cluster &c, double density, bool brushed);

    void InputMouseMotion(int x, int y);
	void InputButtonPress(int button, int x, int y);
	void InputButtonRelease(int button, int x, int y);

};

#endif



