//modified by Jing Yang after 7/6/2001
#ifndef CInterRingClusterTree_H
#define CInterRingClusterTree_H

#include <xmdv/CLinkList.h>
#include <xmdv/InterRing/CInterRingCluster.h>
#include <xmdv/colormap.h>

class CInterRingClusterTree
{
public:
//    char *dim_cluster_file; //file according to which the tree is built;
    CInterRingCluster *root;  //root of the tree;
	int max_level;  //max level of the tree;
    double unit_angle;  //angle responds to one dimension on interRing of this tree;
    double mini_angle;  //the minimum angle a node should keep;
	colormap CMAP;
    void Rotate(double degree);

	CLinkList* current_list;
public:
	CInterRingClusterTree();
	~CInterRingClusterTree();
	
	//set level for every node in the tree, find the max_level of the tree
	void ResetLevels();

    void ResetEntries();
	
	//set start_angles and sweep_angles for all the nodes
	void ResetAngles();
	
	//reset color of all nodes of the tree
	void ResetColors();

    //reorder
    void Reorder();

	void ResetCurrentList();

    virtual void ResetSelection();

	CInterRingCluster* FindNodeAccordingLevelAndAngle(int level, double angle);

	CInterRingCluster* FindNodeAccordingLevelAndAngle(int level, double angle, bool &start, bool &end, bool &in);

    double CInterRingClusterTree::GetDistance(CInterRingCluster *node_1, CInterRingCluster *node_2);

protected:
	//construct the dim cluster tree according to the arrays;
	bool ConstructInterRingClusterTree(int num_nodes, ARR<CInterRingCluster *> nodes, ARR<int> parent_ids);
};

#endif

